﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Xml.Serialization;
using System.Xml;
using System.Text.RegularExpressions;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private playlist matchsettings;


        public Form1()
        {
            InitializeComponent();
        }

        private void Reset()
        {
            matchsettings = new playlist
            {
                gameinfos = new playlistGameinfos
                {
                    game_mode = "0",
                    allwarmupduration = "0",
                    finishtimeout = "1",
                    chat_time = "10000",
                    script_name = "",
                    disablerespawn = "0",
                    forceshowallopponents = "0"
                },
                filter = new playlistFilter
                {
                    is_internet = "1",
                    is_lan = "1"
                },

                map = null
            };

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Reset();
            allwarmupduration.SelectedIndex = 0;
            finishtimeout.SelectedIndex = 1;
        }

        private void ImportToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void GetFiles(FileInfo[] files)
        {
            foreach (FileInfo file in files)
            {
                ListViewItem item = new ListViewItem(file.Name, 1);
                string[] dir = file.DirectoryName.Split('\\');
                bool addString = false;
                string outDir = "";

                for (int x = 0; x < dir.Length; x++)
                {
                    if (addString)
                    {
                        outDir += dir[x] + '\\';
                    }
                    if (dir[x] == "Maps")
                    {
                        addString = true;
                    }
                }

                item.SubItems.Add(outDir);
                item.SubItems.Add(file.Length / 1024 + " kb");
                item.SubItems.Add(file.Extension);
                listView1.Items.Add(item);
                tabControl1.SelectTab(2);
            }
        }



        private String utf8(String utf8String)
        {

            return utf8String;

        }


        private String ConvertUtf8(String str)
        {

            Byte[] bytes = Encoding.Default.GetBytes(str);
            Byte[] utf = Encoding.Convert(Encoding.Default, Encoding.UTF8, bytes);
            return Encoding.UTF8.GetString(utf);
        }


        private void FolderBrowserDialog1_HelpRequest(object sender, EventArgs e)
        {

        }

        private void DataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void SaveXmlToolStripMenuItem_Click(object sender, EventArgs e)
        {

            try
            {
                UpdatePlaylistObject();

                if (listView1.Items.Count == 0)
                {
                    MessageBox.Show("You must import some maps before you can save!", "Error!");
                    return;
                }

                DialogResult result = saveFileDialog1.ShowDialog();


                if (result == DialogResult.OK)
                {
                    try
                    {

                        XmlSerializer ser = new XmlSerializer(typeof(playlist));

                        Encoding encoding = new UTF8Encoding(false);
                        using (FileStream fs = new FileStream(saveFileDialog1.FileName, FileMode.Create))
                        {
                            using (StreamWriter outfile = new StreamWriter(fs, encoding))
                            {
                                ser.Serialize(outfile, matchsettings);
                            }
                        }
                    }
                    catch (Exception exx)
                    {
                        MessageBox.Show("Error while saving file: \r\n" + exx.Message, "Error!");
                        return;
                    }
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show("Error while generating xml: \r\n" + ex.Message, "Error!");
            }

        }

        private void TextBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void loadSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult result = openSettingsFileDialog.ShowDialog();
            if (result == System.Windows.Forms.DialogResult.OK)
            {
                script_name.Text = openSettingsFileDialog.SafeFileName;
            }

        }

        private void gamemode_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void rounds_pointlimit_TextChanged(object sender, EventArgs e)
        {

        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void groupBox7_Enter(object sender, EventArgs e)
        {

        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                foreach (ListViewItem item in listView1.SelectedItems)
                {
                    listView1.Items.Remove(item);
                }
            }

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Reset();
            updateInputboxes();
            listView1.Items.Clear();
        }

        private Boolean getBool(String value)
        {
            if (value != null && value == "1")
            {
                return true;
            }
            return false;
        }

        private String GetBoolStr(Boolean value)
        {
            if (value)
                return "1";
            return "0";
        }

        private void updateInputboxes()
        {

            // gameinfos
            allwarmupduration.SelectedIndex = int.Parse(matchsettings.gameinfos.allwarmupduration);
            chat_time.Text = (String)matchsettings.gameinfos.chat_time;
            disablerespawn.Checked = getBool(matchsettings.gameinfos.disablerespawn);
            forceshowopponents.Checked = getBool(matchsettings.gameinfos.forceshowallopponents);
            script_name.Text = matchsettings.gameinfos.script_name;

            // filter
            is_hotseat.Checked = getBool(matchsettings.filter.is_hotseat);
            is_internet.Checked = getBool(matchsettings.filter.is_internet);
            is_lan.Checked = getBool(matchsettings.filter.is_lan);
            is_solo.Checked = getBool(matchsettings.filter.is_solo);
            random_map_order.Checked = getBool(matchsettings.filter.random_map_order);
            if (matchsettings.map != null)
            {
                foreach (playlistMap map in matchsettings.map)
                {
                    string[] dir = map.file.ToString().Split('/');
                    string file = dir.Last();
                    ListViewItem item = new ListViewItem(file, 1);

                    string outDir = "";
                    for (int x = 0; x < dir.Length - 1; x++)
                    {

                        outDir += dir[x] + '/';

                    }

                    item.SubItems.Add(outDir);
                    listView1.Items.Add(item);
                }

            }
            dataGridView1.Rows.Clear();
            if (matchsettings.mode_script_settings != null)
            {
                foreach (playlistSetting setting in matchsettings.mode_script_settings)
                {
                    try
                    {
                        DataGridViewRow row = new DataGridViewRow();
                        row.CreateCells(dataGridView1, setting);
                        dataGridView1.Rows.Add(setting.name, setting.value, setting.type);
                    }
                    catch (Exception ex)
                    {

                    }
                }
            }
        }

        private void UpdatePlaylistObject()
        {
            if (matchsettings.gameinfos == null)
            {
                matchsettings.gameinfos = new playlistGameinfos();
            }

            if (matchsettings.filter == null)
            {
                matchsettings.filter = new playlistFilter();
            }

            matchsettings.gameinfos.allwarmupduration = allwarmupduration.Text;
            matchsettings.gameinfos.chat_time = chat_time.Text;
            matchsettings.gameinfos.disablerespawn = GetBoolStr(disablerespawn.Checked);
            matchsettings.gameinfos.forceshowallopponents = GetBoolStr(forceshowopponents.Checked);
            matchsettings.gameinfos.game_mode = "0";
            matchsettings.gameinfos.script_name = script_name.Text;
            matchsettings.startindex = "0";

            // filter
            matchsettings.filter.is_hotseat = GetBoolStr(is_hotseat.Checked);
            matchsettings.filter.is_internet = GetBoolStr(is_internet.Checked);
            matchsettings.filter.is_lan = GetBoolStr(is_lan.Checked);
            matchsettings.filter.is_solo = GetBoolStr(is_solo.Checked);
            matchsettings.filter.random_map_order = GetBoolStr(random_map_order.Checked);

            playlistMap[] outmap = new playlistMap[listView1.Items.Count];

            int x = 0;
            String dir_separator = "/";

            foreach (ListViewItem item in listView1.Items)
            {
                Encoding encoder = new UTF8Encoding(true);
                string dir = item.SubItems[1].Text.Replace("\\", dir_separator);
                if (item.SubItems[1].Text == "")
                {
                    dir = "";
                }
                byte[] utf8Bytes = Encoding.UTF8.GetBytes(dir + item.SubItems[0].Text);
                String outString = Encoding.UTF8.GetString(Encoding.UTF8.GetPreamble()) + Encoding.UTF8.GetString(utf8Bytes);

                playlistMap map = new playlistMap
                {
                    file = outString
                };

                outmap[x] = map;
                x++;
            }

            matchsettings.map = outmap;

            List<playlistSetting> settings = new List<playlistSetting>();
            foreach (DataGridViewRow row in dataGridView1.Rows)
            {
                var setting = new playlistSetting();
                foreach (DataGridViewCell cell in row.Cells)
                {
                    switch (cell.ColumnIndex)
                    {
                        case 0:
                            setting.name = (string)cell.Value;
                            break;
                        case 1:
                            setting.value = (string)cell.Value;
                            break;
                        case 2:
                            setting.type = (string)cell.Value;
                            break;
                    }
                }
                if (setting.name != "")
                {
                    if (row.Index < dataGridView1.RowCount - 1)
                    {
                        settings.Add(setting);
                    }
                }

            }
            if (settings.Count > 0)
            {
                matchsettings.mode_script_settings = (playlistSetting[])settings.ToArray();
            }
            else
            {
                matchsettings.mode_script_settings = null;
            }
        }


        private void MapsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result = folderBrowserDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                try
                {
                    String path = folderBrowserDialog1.SelectedPath;
                    DirectoryInfo directory = new DirectoryInfo(path);
                    GetFiles(directory.GetFiles("*.map.gbx", SearchOption.TopDirectoryOnly));
                    // GetFiles(directory.GetFiles("*.challenge.gbx", SearchOption.TopDirectoryOnly));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error has been occured: " + ex.Message);
                }

            }
        }

        private void openSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openSettingsFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            openSettingsFileDialog.FileName = "";
            openSettingsFileDialog.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openSettingsFileDialog.FilterIndex = 1;
            openSettingsFileDialog.RestoreDirectory = true;
            openSettingsFileDialog.Multiselect = false;

            DialogResult result = openSettingsFileDialog.ShowDialog();

            if (result == DialogResult.OK)
            {
                try
                {
                    String path = openSettingsFileDialog.FileName;
                    XmlSerializer serializer = new XmlSerializer(typeof(playlist));

                    using (XmlReader reader = XmlReader.Create(path))
                    {
                        matchsettings = (playlist)serializer.Deserialize(reader);
                    }

                    listView1.Items.Clear();
                    updateInputboxes();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error has been occured: " + ex.Message);
                }

            }


        }

        private void label21_Click(object sender, EventArgs e)
        {

        }

        private int indexOfItemUnderMouseToDrop = 0;

        private void listView1_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);

            foreach (string file in files)
            {
                FileInfo info = new FileInfo(file);

                if (info.Name.ToLower().Contains(".map.gbx"))
                {
                    ListViewItem item = new ListViewItem(info.Name, 1);
                    String[] dir = info.DirectoryName.Split('\\');
                    string outDir = "";
                    bool addString = false;
                    for (int x = 0; x < dir.Length; x++)
                    {
                        if (addString)
                        {
                            outDir += dir[x] + '/';
                        }
                        if (dir[x] == "Maps")
                        {
                            addString = true;
                        }
                    }

                    item.SubItems.Add(outDir);
                    // Insert the item.                   
                    listView1.Items.Insert(indexOfItemUnderMouseToDrop, item);
                }
            }
        }

        private void listView1_GiveFeedback(object sender, GiveFeedbackEventArgs e)
        {
            e.UseDefaultCursors = true;
        }

        private void listView1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effect = DragDropEffects.Copy;
        }



        private void mapsFromXmlToolStripMenuItem_Click(object sender, EventArgs e)
        {

            openSettingsFileDialog.FileName = "";
            openSettingsFileDialog.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openSettingsFileDialog.FilterIndex = 1;
            openSettingsFileDialog.RestoreDirectory = true;

            DialogResult result = openSettingsFileDialog.ShowDialog();

            if (result == DialogResult.OK)
            {
                try
                {
                    String path = openSettingsFileDialog.FileName;
                    XmlSerializer ser = new XmlSerializer(typeof(playlist));
                    playlist loadedSettings;

                    using (XmlReader reader = XmlReader.Create(path))
                    {
                        loadedSettings = (playlist)ser.Deserialize(reader);
                    }

                    foreach (playlistMap map in loadedSettings.map)
                    {
                        string[] dir = map.file.ToString().Split('/');
                        string file = dir.Last();
                        ListViewItem item = new ListViewItem(file, 1);


                        string outDir = "";
                        for (int x = 0; x < dir.Length - 1; x++)
                        {

                            outDir += dir[x] + '/';

                        }

                        item.SubItems.Add(outDir);
                        listView1.Items.Add(item);
                    }

                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error has been occured: " + ex.Message);
                }

            }

        }

        private void listView1_DragOver(object sender, DragEventArgs e)
        {


            try
            {
                Point cp = listView1.PointToClient(new Point(e.X, e.Y));
                ListViewItem dragToItem = listView1.GetItemAt(cp.X, cp.Y);
                indexOfItemUnderMouseToDrop = dragToItem.Index;
            }
            catch (Exception)
            {
                indexOfItemUnderMouseToDrop = listView1.Items.Count;
            }

        }

        private void disablerespawn_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void bnt_selectscript_Click(object sender, EventArgs e)
        {
            openScriptFileDialog.FileName = "";
            openScriptFileDialog.Filter = "script files (*.script.txt)|*.script.txt|All files (*.*)|*.*";
            openScriptFileDialog.FilterIndex = 1;
            openScriptFileDialog.RestoreDirectory = true;
            openScriptFileDialog.Multiselect = false;

            DialogResult result = openScriptFileDialog.ShowDialog();


            if (result == DialogResult.OK)
            {

                String path = openScriptFileDialog.FileName;
                DirectoryInfo directoryInfo = new DirectoryInfo(path);
                script_name.Text = directoryInfo.Name;

                /*  try
                  {
                      List<playlistSetting> settings = new List<playlistSetting>();
                      String path = openScriptFileDialog.FileName;
                      string[] lines = File.ReadAllLines(path);
                      foreach (string line in lines)
                      {
                          // 
                          Regex settingRegEx = new Regex("#Setting\\s+(\\w+)\\s+(.*?)\\s");
                          Match match = settingRegEx.Match(line);
                          if (match.Success)
                          {
                              if (match.Groups.Count >= 3)
                              {
                                  DataGridViewRow row = new DataGridViewRow();
                                  playlistSetting setting = new playlistSetting
                                  {
                                      name = match.Groups[1].Value,
                                      value = match.Groups[2].Value
                                  };
                                  settings.Add(setting);

                                  row.CreateCells(dataGridView1, setting);
                                  dataGridView1.Rows.Add(setting.name, setting.value, "boolean");
                              }

                          }


                      }
                  }
                  catch (Exception)
                  {

                  }
  */
            }
        }
    }
}
